
const initialState = {
    user: null,
    loadingUser: false
}

const state = {
    user: initialState.user,
    loadingUser: !initialState.loadingUser
}

const getters = {
    user(state) {
        return state.user
    },
    companyName(state) {
        return state.user && state.user.company.name
    },
    isManager(state) {
        return state.user && state.user.isManager
    },
    loadingUser(state) {
        return state.loadingUser
    }
}

const mutations = {
    setUser(state, payload) {
        state.user = payload
    },
    setLoadingUser(state, payload) {
        state.loadingUser = !!payload
    }
}

const actions = {
    initUser({ commit }, payload) {
        commit('setUser', payload)
        commit('setLoadingUser')
    },
    resetUser({ getters, commit }) {
        if (!getters.isWired) {
            return
        }

        commit('setLoadingUser', true)
        commit('setUser', null)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}